program rusiavimai;
type mas = array[1..10] of integer;
type mas1 = array[1..79] of integer;
//-------------------------rusiavimas paieska------------------------------
procedure selection(B : mas; ilg : integer);
      var i, min, j, k, lyg, keit : integer;
          kei : boolean;
begin
   writeln('Selection Sort:');
   keit := 0;
   lyg := 0;
   kei := false;
   for j := 1 to ilg-1 do
   begin
    min := j;
    for i := j+1 to ilg do
    begin
        if (B[min] > B[i]) then
        begin
          min := i;
          kei := true;
        end;
        lyg := lyg +1;
    end;
    if kei = true then
    begin
        k := B[j];
        B[j] := B[min];
        B[min] := k;
        keit := keit + 1;
    end;
    for i := 1 to ilg do write(B[i], ' ');
    writeln;
   end;
   writeln;
   write('Keitimu skaicius: ',keit, '; Lyginimu skaicius: ', lyg,'.');
   writeln;
end;
//-------------------------------------------------------------------
//----------------------rusiavimas iterpimu--------------------------
procedure insertion(B : mas; ilg : integer);
      var i, j, lyg, k : integer;
begin
    writeln('Insertion Sort:');
    lyg := 0;
    for i := 2 to ilg do
    begin
        j := i;
        k := B[i];
        while (j <> 1) and (B[j-1] > k) do
        begin
          B[j] := B[j-1];
          j := j-1;
          lyg := lyg +1;
        end;
        B[j] := k;
        for j := 1 to ilg do write(B[j], ' ');
        writeln;
    end;
    writeln('Lyginimu skaicius lygus keitimu skaiciui: ', lyg);
end;
//-------------------------------------------------------------------
//----------------------------burbuliukas----------------------------
procedure bubble(B : mas; ilg : integer);
      var i, j, k, lyg : integer;
begin
    writeln('Bubble sort:');
    lyg := 0;
    for i:= ilg downto 1 do
    begin
       for j := 2 to i do
       if (B[j-1]>B[j]) then
       begin
            k := B[j-1];
            B[j-1] := B[j];
            B[j] := k;
            lyg := lyg +1;
       end;
       for j := 1 to ilg do write(B[j], ' ');
       writeln;
    end;
    writeln('Lyginimo operaciju buvo atlikta tiek pat kiek ir keitimo: ', lyg);
end;
//-------------------------------------------------------------------
//-------------------------Selo rusiavimas---------------------------
procedure shellsort(B : mas; ilg : integer);
      var i, gap, k, lyg, keit, j : integer;
          T : boolean;
begin
    writeln('Shellsort:');
    lyg := 0;
    keit := 0;
    j := 0;
    gap := gap div 2;
    repeat
        begin
        repeat
          T := false;
          for i := 1 to ilg-gap do
          begin
            lyg := lyg +1;
            if (B[i] > B[gap+i]) then
              begin
                k := B[i];
                B[i] := B[gap+i];
                B[gap+i] := k;
                keit := keit +1;
                T := true;
              end;
          end;
        until T = false;
        gap := gap div 2;
        for i := 1 to ilg do write(B[i], ' ');
        writeln;
        end;
    until gap < 1;
    writeln('Lyginimo operaciju buvo atlikta: ', lyg, '; Keitimo : ', keit,'.');
end;
//-------------------------------------------------------------------
//-------------------pasiskirstymo skaiciavimas----------------------
procedure d_counting(B : mas; ilg, min, max : integer);
      var i : integer;
          B1 : mas1;
          B2 : mas;
begin
     writeln('Distribution cunting: ');
     for i := min to max do B1[i] := 0;
     for i := 1 to ilg do
     B1[B[i]] := B1[B[i]] + 1;
     for i := 2 to max do B1[i] := B1[i] + B1[i-1];
     for i := ilg downto 1 do
     begin
       B2[B1[B[i]]] := B[i];
       B1[B[i]] := B1[B[i]] - 1;
     end;
     for i := 1 to ilg do write(B2[i], ' ');
     writeln;
end;
//-------------------------------------------------------------------
//--------------------greitasis rusiavimas---------------------------
procedure quicksort(var a : mas; ap, virs : integer; var lyg, keit : integer);
       var i, j, h, x : integer;
 begin
    if (ap < virs) then
    begin
    j := virs;
    i := ap;
    x := a [(i + j) div 2];        //pivot
    repeat
    begin
        while (a[i] < x) do inc(i);  //visi mazesni i kaire
        while (a[j] > x) do j := j-1;  // visi didesni i desine
        if (i <= j) then
        begin
            h    := a[i];
            a[i] := a[j];
            a[j] := h;
            inc(i);
            j := j-1;
            keit := keit + 1;
        end;
        lyg := lyg + 1;
    end;
    until (j < i);
    if (ap < j) then quicksort(a, ap, j, lyg, keit);          //kaire skaldo
    if (i < virs) then quicksort(a, i, virs, lyg, keit);      //desine skaldo
    end;
 end;
//-------------------------------------------------------------------
function bits(x, k, j : integer): integer;
     var i : integer;
         a, b : longint;
begin
    a := 1;
    b := 1;
    for i := 1 to k do
        a := a * 2;
    for i := 1 to j do
        b := b * 2;
    bits := (x div a) mod b;
end;
//-------------------------------------------------------------------
//--------------------skaitmeninio keitimo---------------------------
procedure radix_exchange(var b : mas; l, ilg, a : integer);
      var i, j, t, u : integer;
begin
    if (ilg > l) and (a >= 0) then
    begin
        i := l; j := ilg;
        repeat
            while (bits(b[i], a, 1) = 0) and (i < j) do inc(i);
            while (bits(b[j], a, 1) = 1) and (i < j) do dec(j);
            t := b[i]; b[i] := b[j]; b[j] := t;
        until j = i;
        if bits(b[ilg], a, 1) = 0 then inc(j);
        radix_exchange(b, l, j-1, a-1);
        radix_exchange(b, j, ilg, a-1);
    end;
end;
//-------------------------------------------------------------------
{procedure straight_radix(); }
//------------------------rusiavimas suliejimu-----------------------
procedure merge(var min, mid, max : integer; var B : mas);
      var i, j, k : integer;
          B1 : mas;
begin
    // ir su lyginiu elementu skaicium, ir su nelyginiu tinka */
    i := 1;
    for j := min to mid do
    begin
        B1[i] := B[j];
        inc(i);
    end;
    i := 1;
    k := min;
    while (k < j) and (j <= max) do
    begin
             if (B1[i] > B[j]) then
             begin
                 inc(k);
                 inc(j);
                 B1[k] := B[j];
             end
             else
             begin
                 inc(k);
                 inc(i);
                 B[k] := B1[i];
             end;
    end;
    if (max - j + 1 > 0) then
         for k:=k to j-1 do
         begin
             inc(i);
             B[k] := B1[i];
         end;
end;
//...................................................................
{procedure mergeSort(var min, max : integer; var B : mas);
      var mid : integer;
begin
    mid := (min + max) div 2;
    if (min < max) then
    begin
                 mergeSort (min, mid, B);
                 inc(mid);
                 mergeSort (mid, max, B);
                 merge (min, mid, max, B);
    end;
end;
//-------------------------------------------------------------------    }
//procedure externalsorting();
var m, u : mas;
    kiek, i1, i2, i : integer;
begin
    kiek := 10;
    m[1] := 5; m[2] := 6; m[3] := 45; m[4]:=16; m[5] := 25; m[6] := 3; m[7] := 1; m[8]:=7; m[9]:=79; m[10]:=45;
    //(5, 6, 45, 16, 25, 3, 1, 7, 79, 45)
    selection(m, kiek);
    insertion(m, kiek);
    bubble(m, kiek);
    shellsort(m, kiek);
    i1 := 1;               //reiksmiu reziai
    i2 := 79;
    d_counting(m, kiek, i1, i2);
    i1 := 0;
    i2 := 0;
    u := m;
    quicksort(u, 1, kiek, i1, i2);
    writeln('Quicksort: ');
    for i := 1 to kiek do write(u[i], ' ');
    writeln;
    writeln('Keitimo operaciju buvo atlikta: ', i2, ', lyginimo: ', i1,'.');
    i1 := 1;
    i2 := 30;
    u := m;
    writeln('Radix sorting:');
    radix_exchange(u, i1, kiek, i2);
    for i1 := 1 to 10 do write(u[i1], ' ');
    writeln;
    u := m;
    i1 := 0;
    //mergeSort(i1, kiek, u);
   // writeln('Mergesort: ');
 //   for i := 1 to kiek do write(u[i], ' ');
    readln;
end.
